diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lr-wpan/model/lr-wpan-mac-base.h ns-3.44/src/lr-wpan/model/lr-wpan-mac-base.h
--- ns-3.43/src/lr-wpan/model/lr-wpan-mac-base.h	2024-10-09 16:41:09.900656000 -0700
+++ ns-3.44/src/lr-wpan/model/lr-wpan-mac-base.h	2025-03-09 16:55:49.419371100 -0700
@@ -9,13 +9,13 @@
 #ifndef LR_WPAN_MAC_BASE_H
 #define LR_WPAN_MAC_BASE_H
 
-#include <ns3/callback.h>
-#include <ns3/mac16-address.h>
-#include <ns3/mac64-address.h>
-#include <ns3/nstime.h>
-#include <ns3/object.h>
-#include <ns3/packet.h>
-#include <ns3/ptr.h>
+#include "ns3/callback.h"
+#include "ns3/mac16-address.h"
+#include "ns3/mac64-address.h"
+#include "ns3/nstime.h"
+#include "ns3/object.h"
+#include "ns3/packet.h"
+#include "ns3/ptr.h"
 
 #include <cstdint>
 
@@ -25,7 +25,7 @@
 {
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * The status of a confirm or an indication primitive as a result of a previous request.
  * Represent the value of status in IEEE 802.15.4-2011 primitives.
@@ -79,7 +79,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * table 80 of 802.15.4
  */
@@ -92,7 +92,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * Table 30 of IEEE 802.15.4-2011
  */
@@ -105,7 +105,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MCPS-DATA.request params. See 7.1.1.1
  */
@@ -121,7 +121,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-START.request params. See 802.15.4-2011  Section 6.2.12.1
  */
@@ -145,7 +145,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-SCAN.request params. See IEEE 802.15.4-2011  Section 6.2.10.1 Table 30
  */
@@ -164,7 +164,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-ASSOCIATE.request params. See 802.15.4-2011  Section 6.2.2.1
  */
@@ -184,7 +184,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-ASSOCIATE.response params. See 802.15.4-2011 6.2.2.3.
  */
@@ -199,7 +199,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-ORPHAN.response params. See  802.15.4-2011   Section 6.2.7.2
  */
@@ -211,7 +211,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-SYNC.request params. See 802.15.4-2011  Section 6.2.13.1
  */
@@ -223,7 +223,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-POLL.request params. See 802.15.4-2011  Section 6.2.14.1
  */
@@ -237,7 +237,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * IEEE 802.15.4-2006 PHY and MAC PIB Attribute Identifiers Table 23 and Table 86.
  * Note: Attribute identifiers use standardized values.
@@ -294,19 +294,19 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * IEEE802.15.4-2011 PHY PIB Attributes Table 52 in section 6.4.2
  */
 struct MacPibAttributes : public SimpleRefCount<MacPibAttributes>
 {
-    std::vector<uint8_t> macBeaconPayload; //!< The set with the contents of the beacon payload.
-    uint8_t macBeaconPayloadLength{0};     //!< The length in octets of the beacon payload.
-    Mac16Address macShortAddress;          //!< The 16 bit mac short address
-    Mac64Address macExtendedAddress;       //!< The EUI-64 bit address
-    uint16_t macPanId{0xffff};             //!< The identifier of the PAN
-    bool macAssociationPermit{true};       //!< Indication of whether the coordinator is allowing
-                                           //!< association.
+    std::vector<uint8_t> macBeaconPayload{}; //!< The set with the contents of the beacon payload.
+    uint8_t macBeaconPayloadLength{0};       //!< The length in octets of the beacon payload.
+    Mac16Address macShortAddress;            //!< The 16 bit mac short address
+    Mac64Address macExtendedAddress;         //!< The EUI-64 bit address
+    uint16_t macPanId{0xffff};               //!< The identifier of the PAN
+    bool macAssociationPermit{true};         //!< Indication of whether the coordinator is allowing
+                                             //!< association.
     bool macRxOnWhenIdle{true}; //!< Indication of whether the MAC is enabled during idle periods.
     bool macPromiscuousMode{false}; //!< Indication of whether the mac is in promiscuous mode
                                     //!<  (Receive all mode).
@@ -316,7 +316,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MCPS-DATA.confirm params. See 7.1.1.2
  */
@@ -328,7 +328,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MCPS-DATA.indication params. See 7.1.1.3
  */
@@ -347,7 +347,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-ASSOCIATE.indication params. See 802.15.4-2011 6.2.2.2.
  */
@@ -361,7 +361,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-COMM-STATUS.indication params. See  802.15.4-2011   Section 6.2.4.2 Table 18
  */
@@ -383,7 +383,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-ORPHAN.indication params. See  802.15.4-2011   Section 6.2.7.1
  */
@@ -393,7 +393,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-START.confirm params. See  802.15.4-2011   Section 6.2.12.2
  */
@@ -404,7 +404,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * PAN Descriptor, Table 17 IEEE 802.15.4-2011
  */
@@ -431,7 +431,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-SCAN.confirm params. See IEEE 802.15.4-2011 Section 6.2.10.2
  */
@@ -453,7 +453,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-ASSOCIATE.confirm params. See 802.15.4-2011  Section 6.2.2.4
  */
@@ -465,7 +465,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-BEACON-NOTIFY.indication params. See  802.15.4-2011   Section 6.2.4.1, Table 16
  */
@@ -478,7 +478,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-SYNC-LOSS.indication params. See  802.15.4-2011   Section 6.2.13.2, Table 37
  */
@@ -493,7 +493,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-SET.confirm params. See  802.15.4-2011   Section 6.2.11.2
  */
@@ -502,11 +502,13 @@
     MacStatus m_status{MacStatus::UNSUPPORTED_ATTRIBUTE}; //!< The result of
                                                           //!< the request to write
                                                           //!< the PIB attribute.
-    MacPibAttributeIdentifier id; //!< The id of the PIB attribute that was written.
+    MacPibAttributeIdentifier id{
+        MacPibAttributeIdentifier::unsupported}; //!< The id of the
+                                                 //!< PIB attribute that was written.
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * MLME-START.confirm params. See  802.15.4-2011   Section 6.2.14.2
  */
@@ -518,7 +520,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a McpsDataRequest has been called from
  * the higher layer.  It returns a status of the outcome of the
@@ -527,18 +529,18 @@
 using McpsDataConfirmCallback = Callback<void, McpsDataConfirmParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a Mcps has successfully received a
  *  frame and wants to deliver it to the higher layer.
  *
- *  \todo for now, we do not deliver all of the parameters in section
+ *  @todo for now, we do not deliver all of the parameters in section
  *  802.15.4-2006 7.1.1.3.1 but just send up the packet.
  */
 using McpsDataIndicationCallback = Callback<void, McpsDataIndicationParams, Ptr<Packet>>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a Mlme has successfully received a command
  *  frame and wants to deliver it to the higher layer.
@@ -549,7 +551,7 @@
 using MlmeAssociateIndicationCallback = Callback<void, MlmeAssociateIndicationParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called by the MLME and issued to its next higher layer following
  * a transmission instigated through a response primitive.
@@ -560,7 +562,7 @@
 using MlmeCommStatusIndicationCallback = Callback<void, MlmeCommStatusIndicationParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called by the MLME and issued to its next higher layer following
  * the reception of a orphan notification.
@@ -571,7 +573,7 @@
 using MlmeOrphanIndicationCallback = Callback<void, MlmeOrphanIndicationParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a MlmeStartRequest has been called from
  * the higher layer.  It returns a status of the outcome of the
@@ -580,7 +582,7 @@
 using MlmeStartConfirmCallback = Callback<void, MlmeStartConfirmParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a MlmeScanRequest has been called from
  * the higher layer.  It returns a status of the outcome of the scan.
@@ -588,7 +590,7 @@
 using MlmeScanConfirmCallback = Callback<void, MlmeScanConfirmParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a MlmeAssociateRequest has been called from
  * the higher layer. It returns a status of the outcome of the
@@ -597,29 +599,29 @@
 using MlmeAssociateConfirmCallback = Callback<void, MlmeAssociateConfirmParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a Mlme has successfully received a
  *  beacon frame and wants to deliver it to the higher layer.
  *
- *  \todo for now, we do not deliver all of the parameters in section
+ *  @todo for now, we do not deliver all of the parameters in section
  *  802.15.4-2006 6.2.4.1 but just send up the packet.
  */
 using MlmeBeaconNotifyIndicationCallback = Callback<void, MlmeBeaconNotifyIndicationParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called to indicate the loss of synchronization with
  * a coordinator.
  *
- * \todo for now, we do not deliver all of the parameters in section
+ * @todo for now, we do not deliver all of the parameters in section
  *  See IEEE 802.15.4-2011 6.2.13.2.
  */
 using MlmeSyncLossIndicationCallback = Callback<void, MlmeSyncLossIndicationParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a MlmeSetRequest has been called from
  * the higher layer to set a PIB. It returns a status of the outcome of the
@@ -628,7 +630,7 @@
 using MlmeSetConfirmCallback = Callback<void, MlmeSetConfirmParams>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a MlmeGetRequest has been called from
  * the higher layer to get a PIB. It returns a status of the outcome of the
@@ -638,7 +640,7 @@
     Callback<void, MacStatus, MacPibAttributeIdentifier, Ptr<MacPibAttributes>>;
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * This callback is called after a Mlme-Poll.Request has been called from
  * the higher layer.  It returns a status of the outcome of the
@@ -647,9 +649,9 @@
 using MlmePollConfirmCallback = Callback<void, MlmePollConfirmParams>;
 
 /**
- * \ingroup netdevice
+ * @ingroup netdevice
  *
- * \brief Lr-wpan MAC layer abstraction
+ * @brief Lr-wpan MAC layer abstraction
  *
  * This class defines the interface functions (primitives) used by a IEEE 802.15.4-2011 compliant
  * MAC layer. Any lr-wpan MAC should extend from this class and implement the
@@ -660,8 +662,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     ~LrWpanMacBase() override;
@@ -671,8 +673,8 @@
      * MCPS-DATA.request
      * Request to transfer a MSDU.
      *
-     * \param params the request parameters
-     * \param p the packet to be transmitted
+     * @param params the request parameters
+     * @param p the packet to be transmitted
      */
     virtual void McpsDataRequest(McpsDataRequestParams params, Ptr<Packet> p) = 0;
 
@@ -682,7 +684,7 @@
      * Request to allow a PAN coordinator to initiate
      * a new PAN or beginning a new superframe configuration.
      *
-     * \param params the request parameters
+     * @param params the request parameters
      */
     virtual void MlmeStartRequest(MlmeStartRequestParams params) = 0;
 
@@ -691,7 +693,7 @@
      * MLME-SCAN.request
      * Request primitive used to initiate a channel scan over a given list of channels.
      *
-     * \param params the scan request parameters
+     * @param params the scan request parameters
      */
     virtual void MlmeScanRequest(MlmeScanRequestParams params) = 0;
 
@@ -701,7 +703,7 @@
      * Request primitive used by a device to request an association with
      * a coordinator.
      *
-     * \param params the request parameters
+     * @param params the request parameters
      */
     virtual void MlmeAssociateRequest(MlmeAssociateRequestParams params) = 0;
 
@@ -711,7 +713,7 @@
      * Primitive used to initiate a response to an MLME-ASSOCIATE.indication
      * primitive.
      *
-     * \param params the associate response parameters
+     * @param params the associate response parameters
      */
     virtual void MlmeAssociateResponse(MlmeAssociateResponseParams params) = 0;
 
@@ -721,7 +723,7 @@
      * Request to synchronize with the coordinator by acquiring and,
      * if specified, tracking beacons.
      *
-     * \param params the request parameters
+     * @param params the request parameters
      */
     virtual void MlmeSyncRequest(MlmeSyncRequestParams params) = 0;
 
@@ -730,7 +732,7 @@
      * MLME-POLL.request
      * Prompts the device to request data from the coordinator.
      *
-     * \param params the request parameters
+     * @param params the request parameters
      */
     virtual void MlmePollRequest(MlmePollRequestParams params) = 0;
 
@@ -740,7 +742,7 @@
      * Primitive used to initiatte a response to an MLME-ORPHAN.indication
      * primitive.
      *
-     * \param params the orphan response parameters
+     * @param params the orphan response parameters
      */
     virtual void MlmeOrphanResponse(MlmeOrphanResponseParams params) = 0;
 
@@ -749,8 +751,8 @@
      * MLME-SET.request
      * Attempts to write the given value to the indicated PIB attribute.
      *
-     * \param id the attributed identifier
-     * \param attribute the attribute value
+     * @param id the attributed identifier
+     * @param attribute the attribute value
      */
     virtual void MlmeSetRequest(MacPibAttributeIdentifier id, Ptr<MacPibAttributes> attribute) = 0;
 
@@ -761,7 +763,7 @@
      * Note: The PibAttributeIndex parameter is not included because
      * attributes that represent tables are not supported.
      *
-     * \param id the attribute identifier
+     * @param id the attribute identifier
      */
     virtual void MlmeGetRequest(MacPibAttributeIdentifier id) = 0;
 
@@ -770,7 +772,7 @@
      * The callback implements MCPS-DATA.confirm SAP of IEEE 802.15.4-2006,
      * section 7.1.1.2.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMcpsDataConfirmCallback(McpsDataConfirmCallback c);
 
@@ -779,7 +781,7 @@
      * The callback implements MCPS-DATA.indication SAP of IEEE 802.15.4-2006,
      * section 7.1.1.3.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMcpsDataIndicationCallback(McpsDataIndicationCallback c);
 
@@ -788,7 +790,7 @@
      * The callback implements MLME-ASSOCIATE.indication SAP of IEEE 802.15.4-2011,
      * section 6.2.2.2.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeAssociateIndicationCallback(MlmeAssociateIndicationCallback c);
 
@@ -797,7 +799,7 @@
      * The callback implements MLME-COMM-STATUS.indication SAP of IEEE 802.15.4-2011,
      * section 6.2.4.2.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeCommStatusIndicationCallback(MlmeCommStatusIndicationCallback c);
 
@@ -806,7 +808,7 @@
      * The callback implements MLME-ORPHAN.indication SAP of IEEE 802.15.4-2011,
      * section 6.2.7.1.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeOrphanIndicationCallback(MlmeOrphanIndicationCallback c);
 
@@ -815,7 +817,7 @@
      * The callback implements MLME-START.confirm SAP of IEEE 802.15.4-2006,
      * section 7.1.14.2.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeStartConfirmCallback(MlmeStartConfirmCallback c);
 
@@ -824,7 +826,7 @@
      * The callback implements MLME-SCAN.confirm SAP of IEEE 802.15.4-2011,
      * section 6.2.10.2.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeScanConfirmCallback(MlmeScanConfirmCallback c);
 
@@ -833,7 +835,7 @@
      * The callback implements MLME-ASSOCIATE.confirm SAP of IEEE 802.15.4-2011,
      * section 6.2.2.4.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeAssociateConfirmCallback(MlmeAssociateConfirmCallback c);
 
@@ -842,7 +844,7 @@
      * The callback implements MLME-BEACON-NOTIFY.indication SAP of IEEE 802.15.4-2011,
      * section 6.2.4.1.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeBeaconNotifyIndicationCallback(MlmeBeaconNotifyIndicationCallback c);
 
@@ -851,7 +853,7 @@
      * The callback implements MLME-SYNC-LOSS.indication SAP of IEEE 802.15.4-2011,
      * section 6.2.13.2.
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeSyncLossIndicationCallback(MlmeSyncLossIndicationCallback c);
 
@@ -860,7 +862,7 @@
      * The callback implements MLME-SET.confirm SAP of IEEE 802.15.4-2011,
      * section 6.2.11.2
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeSetConfirmCallback(MlmeSetConfirmCallback c);
 
@@ -869,7 +871,7 @@
      * The callback implements MLME-GET.confirm SAP of IEEE 802.15.4-2011,
      * section 6.2.5.2
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmeGetConfirmCallback(MlmeGetConfirmCallback c);
 
@@ -878,7 +880,7 @@
      * The callback implements MLME-POLL.confirm SAP of IEEE 802.15.4-2011,
      * section 6.2.14.2
      *
-     * \param c the callback
+     * @param c the callback
      */
     void SetMlmePollConfirmCallback(MlmePollConfirmCallback c);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lr-wpan/model/lr-wpan-mac.cc ns-3.44/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.43/src/lr-wpan/model/lr-wpan-mac.cc	2024-10-09 16:41:09.900656000 -0700
+++ ns-3.44/src/lr-wpan/model/lr-wpan-mac.cc	2025-03-09 16:55:49.419371100 -0700
@@ -19,13 +19,13 @@
 #include "lr-wpan-mac-pl-headers.h"
 #include "lr-wpan-mac-trailer.h"
 
-#include <ns3/double.h>
-#include <ns3/log.h>
-#include <ns3/node.h>
-#include <ns3/packet.h>
-#include <ns3/random-variable-stream.h>
-#include <ns3/simulator.h>
-#include <ns3/uinteger.h>
+#include "ns3/double.h"
+#include "ns3/log.h"
+#include "ns3/node.h"
+#include "ns3/packet.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/simulator.h"
+#include "ns3/uinteger.h"
 
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT                                                                      \
@@ -76,7 +76,7 @@
         break;
     }
     return os;
-};
+}
 
 TypeId
 LrWpanMac::GetTypeId()
@@ -252,11 +252,14 @@
 
 LrWpanMac::~LrWpanMac()
 {
+    NS_LOG_FUNCTION(this);
 }
 
 void
 LrWpanMac::DoInitialize()
 {
+    NS_LOG_FUNCTION(this);
+
     if (m_macRxOnWhenIdle)
     {
         m_phy->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_RX_ON);
@@ -272,6 +275,8 @@
 void
 LrWpanMac::DoDispose()
 {
+    NS_LOG_FUNCTION(this);
+
     if (m_csmaCa)
     {
         m_csmaCa->Dispose();
@@ -291,6 +296,7 @@
     }
     m_indTxQueue.clear();
 
+    m_uniformVar = nullptr;
     m_phy = nullptr;
     m_mcpsDataConfirmCallback = MakeNullCallback<void, McpsDataConfirmParams>();
     m_mcpsDataIndicationCallback = MakeNullCallback<void, McpsDataIndicationParams, Ptr<Packet>>();
@@ -313,6 +319,7 @@
     m_scanEnergyEvent.Cancel();
     m_scanOrphanEvent.Cancel();
     m_beaconEvent.Cancel();
+    m_assocResCmdWaitTimeout.Cancel();
 
     Object::DoDispose();
 }
@@ -675,6 +682,8 @@
     // obtained from those operations.
     m_pendPrimitive = MLME_ASSOC_REQ;
     m_associateParams = params;
+    m_ignoreDataCmdAck = false;
+
     bool invalidRequest = false;
 
     if (params.m_coordPanId == 0xffff)
@@ -1036,8 +1045,7 @@
     else
     {
         // Extract the octets from m_macBeaconPayload and place them in a packet
-        uint8_t* octets = &m_macBeaconPayload[0];
-        beaconPacket = Create<Packet>(octets, m_macBeaconPayload.size());
+        beaconPacket = Create<Packet>(m_macBeaconPayload.data(), m_macBeaconPayload.size());
     }
 
     LrWpanMacHeader macHdr(LrWpanMacHeader::LRWPAN_MAC_BEACON, m_macBsn.GetValue());
@@ -2306,10 +2314,28 @@
                     case CommandPayloadHeader::ASSOCIATION_REQ:
                         NS_LOG_DEBUG("Association Request Command Received; processing ACK");
                         break;
-                    case CommandPayloadHeader::ASSOCIATION_RESP:
-                        m_assocResCmdWaitTimeout.Cancel(); // cancel event to a lost assoc resp cmd.
-                        NS_LOG_DEBUG("Association Response Command Received; processing ACK");
+                    case CommandPayloadHeader::ASSOCIATION_RESP: {
+                        if (m_assocResCmdWaitTimeout.IsPending())
+                        {
+                            m_assocResCmdWaitTimeout
+                                .Cancel(); // cancel event to a lost assoc resp cmd.
+                            NS_LOG_DEBUG("Association Response Command Received; processing ACK");
+                        }
+                        else
+                        {
+                            // Association response command was received before (or never received)
+                            // a Data request command ACK. This is an extreme case and it is
+                            // essentially caused by saturation in the network.
+                            // We turn a flag ON to not react once
+                            // we finally receive the Data request command ACK. This behavior is not
+                            // standard, but necessary to address this flaw in design of the
+                            // original association process.
+                            m_ignoreDataCmdAck = true;
+                            NS_LOG_DEBUG("Assoc. Resp Cmd received before Data Req. Cmd. in "
+                                         "Association request");
+                        }
                         break;
+                    }
                     default:
                         break;
                     }
@@ -2499,15 +2525,18 @@
                             }
 
                             case CommandPayloadHeader::DATA_REQ: {
-                                // Schedule an event in case the Association Response Command never
-                                // reached this device during an association process.
-                                double symbolRate = m_phy->GetDataOrSymbolRate(false);
-                                Time waitTime = Seconds(
-                                    static_cast<double>(m_assocRespCmdWaitTime) / symbolRate);
-                                m_assocResCmdWaitTimeout =
-                                    Simulator::Schedule(waitTime,
-                                                        &LrWpanMac::LostAssocRespCommand,
-                                                        this);
+                                if (!m_ignoreDataCmdAck)
+                                {
+                                    // Schedule an event in case the Association Response Command
+                                    // never reached this device during an association process.
+                                    double symbolRate = m_phy->GetDataOrSymbolRate(false);
+                                    Time waitTime = Seconds(
+                                        static_cast<double>(m_assocRespCmdWaitTime) / symbolRate);
+                                    m_assocResCmdWaitTimeout =
+                                        Simulator::Schedule(waitTime,
+                                                            &LrWpanMac::LostAssocRespCommand,
+                                                            this);
+                                }
 
                                 if (!m_mlmePollConfirmCallback.IsNull())
                                 {
